/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
	"time"
)

// checks if the CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata{}

// CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata struct for CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata
type CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata struct {
	OrgId *string `json:"orgId,omitempty"`
	ShortName *string `json:"shortName,omitempty"`
	DateUpdated *time.Time `json:"dateUpdated,omitempty"`
}

// NewCreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata instantiates a new CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata() *CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata {
	this := CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata{}
	return &this
}

// NewCreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadataWithDefaults instantiates a new CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadataWithDefaults() *CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata {
	this := CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata{}
	return &this
}

// GetOrgId returns the OrgId field value if set, zero value otherwise.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata) GetOrgId() string {
	if o == nil || IsNil(o.OrgId) {
		var ret string
		return ret
	}
	return *o.OrgId
}

// GetOrgIdOk returns a tuple with the OrgId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata) GetOrgIdOk() (*string, bool) {
	if o == nil || IsNil(o.OrgId) {
		return nil, false
	}
	return o.OrgId, true
}

// HasOrgId returns a boolean if a field has been set.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata) HasOrgId() bool {
	if o != nil && !IsNil(o.OrgId) {
		return true
	}

	return false
}

// SetOrgId gets a reference to the given string and assigns it to the OrgId field.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata) SetOrgId(v string) {
	o.OrgId = &v
}

// GetShortName returns the ShortName field value if set, zero value otherwise.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata) GetShortName() string {
	if o == nil || IsNil(o.ShortName) {
		var ret string
		return ret
	}
	return *o.ShortName
}

// GetShortNameOk returns a tuple with the ShortName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata) GetShortNameOk() (*string, bool) {
	if o == nil || IsNil(o.ShortName) {
		return nil, false
	}
	return o.ShortName, true
}

// HasShortName returns a boolean if a field has been set.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata) HasShortName() bool {
	if o != nil && !IsNil(o.ShortName) {
		return true
	}

	return false
}

// SetShortName gets a reference to the given string and assigns it to the ShortName field.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata) SetShortName(v string) {
	o.ShortName = &v
}

// GetDateUpdated returns the DateUpdated field value if set, zero value otherwise.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata) GetDateUpdated() time.Time {
	if o == nil || IsNil(o.DateUpdated) {
		var ret time.Time
		return ret
	}
	return *o.DateUpdated
}

// GetDateUpdatedOk returns a tuple with the DateUpdated field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata) GetDateUpdatedOk() (*time.Time, bool) {
	if o == nil || IsNil(o.DateUpdated) {
		return nil, false
	}
	return o.DateUpdated, true
}

// HasDateUpdated returns a boolean if a field has been set.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata) HasDateUpdated() bool {
	if o != nil && !IsNil(o.DateUpdated) {
		return true
	}

	return false
}

// SetDateUpdated gets a reference to the given time.Time and assigns it to the DateUpdated field.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata) SetDateUpdated(v time.Time) {
	o.DateUpdated = &v
}

func (o CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OrgId) {
		toSerialize["orgId"] = o.OrgId
	}
	if !IsNil(o.ShortName) {
		toSerialize["shortName"] = o.ShortName
	}
	if !IsNil(o.DateUpdated) {
		toSerialize["dateUpdated"] = o.DateUpdated
	}
	return toSerialize, nil
}

type NullableCreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata struct {
	value *CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata
	isSet bool
}

func (v NullableCreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata) Get() *CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata {
	return v.value
}

func (v *NullableCreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata) Set(val *CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata(val *CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata) *NullableCreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata {
	return &NullableCreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata{value: val, isSet: true}
}

func (v NullableCreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


